
#include <stdio.h>
#include <string.h>
#include <mem.h>
#include <conio.h>
#include <dos.h>
#include <ctype.h>

#include "dpmi.h"
#include "keyb.h"
#include "cgdk.h"
#include "timer.h"
#include "wait.h"
#include "com.h"
#include "comirq.h"

//#define COM_DEBUG

#define BIOS_SEG 0
#define BIOS_COM_PORTS 0x400

#define COM_PORTSETUP 3
#define COM_PORTINTERRUPTS 1
#define COM_PORTSETSPEED 0x80
#define COM_PORTSETUPNORMAL 3
#define COM_PORTSTATUS 5

#define COM_INTID 2
#define COM_INTIDRECEIVE 4
#define COM_INTIDSEND 2

#define COM_INTSEND 1
#define COM_INTRECEIVE 2
#define COM_INTBOTH 3

#define COM_PORTMODEM 4
#define COM_OUT2 8
#define COM_OUT2BIT 4

#define COM_110BAUDS 1040
#define COM_150BAUDS 768
#define COM_300BAUDS 384
#define COM_600BAUDS 192
#define COM_1200BAUDS 96
#define COM_2400BAUDS 48
#define COM_4800BAUDS 24
#define COM_9600BAUDS 12
#define COM_19200BAUDS 6
#define COM_38400BAUDS 3
#define COM_57600BAUDS 2
#define COM_115200BAUDS 1

#define COM_INTERRUPT_AUTODETECT -1

#define COM_INITERR_PORT -1
#define COM_INITERR_IRQ -2

#define COM_INVALIDIRQ -1
#define COM_INVALIDINT -1

static void interrupt far (*COM_irqOld) (INTERRUPT_ARG);
long COM_irqOld16;

#define COM_DATA_COMMANDCHAR '~'
#define COM_DATA_COMMAND 0xFFFF // ((COM_DATA_COMMANDCHAR << 8) + COM_DATA_COMMANDCHAR)
#define COM_COMMAND_NOTHING     0x00000000
#define COM_COMMAND_LOGIN       0x50676f4c // LogP
#define COM_COMMAND_LOGINMASTER 0x4d676f4c // LogM
#define COM_COMMAND_LOGINSLAVE  0x53676f4c // LogS
#define COM_COMMAND_LOGOUT      0x4f676f4c // LogO
#define COM_COMMAND_ID          0x49676f4c // LogI

#define COM_SENDCOMMAND_DELAY 200
#define COM_DONE_DELAY 1000
#define COM_LOG_DELAY 1000

#define COM_USER_NOTHING 0
#define COM_USER_TEMP 1
#define COM_USER_PEER 2
#define COM_USER_MASTER 3
#define COM_USER_SLAVE 4

#define COM_BIOS_INTERRUPT 0x14

short COM_portAddr [4+1];
int COM_irqInt [] = {0, COM_INVALIDINT, COM_INVALIDINT,
                     0xB, 0xC, 0xE, COM_INVALIDINT, 0xF};
int COM_irqNum [] = {COM_INVALIDIRQ, 4, 3, 4, 3};

int COM_port;
int COM_addr;
int COM_irq;
int COM_int;
static int COM_speed;
long COM_baudSpeed;
long COM_byteSpeed;

long COM_command;
int COM_user;

//long COM_bytesReceived;
//long COM_buf->bytesSent;
//static int COM_buf->bytesSentLock;
//static long COM_unlocked;

#define ID_LEN (COM_NAME_MAXLEN+sizeof (long)+sizeof (short))
//#define ID_STRING "Cybertek Serial Communication Driver version 1.00 "
#define ID_STRING "Cybertek SCD 1.00 "

struct TCOMPacket
{
  long command;
  char name [COM_NAME_MAXLEN];
};

struct TID
{
  unsigned short dataSize;
  TCOMPacket com;
};

TID idRightPacket = {COM_DATA_COMMAND, COM_COMMAND_ID, ID_STRING};
char *idRight = (char *) &idRightPacket;

char COM_remoteName [COM_NAME_MAXLEN+1];
char COM_localName [COM_NAME_MAXLEN+1];
static char COM_defNameMaster [] = "Master";
static char COM_defNameSlave [] = "Slave";
static char COM_defNamePeer [] = "Peer";

//char *rbuf;
//char *sbuf;

//static short rbufpos;
//static short COM_buf->rend;
//static short COM_buf->spos;
//static short COM_buf->send;


TCOM_buf *COM_buf;

#pragma off (check_stack)
void interrupt far COM_irqHandler (INTERRUPT_ARG)
{
  char c;
  TCOM_buf *comBuf;

  comBuf = (TCOM_buf *) COM_buf;

  switch (inp (comBuf->addr+COM_INTID))
  {
    case COM_INTIDRECEIVE:
    {
      c = inp (comBuf->addr);
      if (!comBuf->receiveLock)
      {
        comBuf->bytesReceived++;
        comBuf->r [comBuf->rpos] = c;
        comBuf->rpos++;
        if (comBuf->rpos == R_BUF_SIZE)
        {
          comBuf->rpos = 0;
        }
      }
      break;
    }
    case COM_INTIDSEND:
    {
      if (comBuf->spos == comBuf->send)
      {
        comBuf->sendLock=0;
      }
      else
      {
        comBuf->bytesSent++;
        outp (comBuf->addr, comBuf->s [comBuf->spos]);
        comBuf->sendLock=1;
        comBuf->spos++;
        if (comBuf->spos == S_BUF_SIZE)
        {
          comBuf->spos = 0;
        }
      }
      break;
    }
  }

  outp (PIC, END_OF_PIC);
}

//#define __TURBOC__
//void *COM_buf;


int COM_sendData (char *s, int dataSize)
{
  int rest;

  if (COM_user)
  {
    if (dataSize)
    {
      rest = S_BUF_SIZE - COM_buf->send;

      if ((COM_buf->send == COM_buf->spos) && (!COM_buf->sendLock))
      {
        outp (COM_addr, s [0]);
        COM_buf->sendLock=1;
        COM_buf->bytesSent++;
        s++;
        dataSize--;
      }

      if (rest >= dataSize)
      {
        memcpy ((char *)COM_buf->s+COM_buf->send, s, dataSize);
        COM_buf->send += dataSize;
      }
      else
      {
        memcpy ((char *)COM_buf->s+COM_buf->send, s, rest);
        memcpy ((char *)COM_buf->s, s+rest, dataSize-rest);
        COM_buf->send = dataSize-rest;
      }
    }
  }
  else
  {
    return 0;
  }
  return dataSize;
}


static int COM_receiveData (char *s, int dataSize)
{
  int rest;

  if (COM_user)
  {
    if (dataSize)
    {
      if (COM_buf->rend <= COM_buf->rpos)
      {
        if ((COM_buf->rpos - COM_buf->rend) >= dataSize)
        {
          memcpy (s, (char *)COM_buf->r+COM_buf->rend, dataSize);
          COM_buf->rend+=dataSize;
          return dataSize;
        }
        else
        {
          #ifdef COM_DEBUG

          if (kbhit ())
          {
            COM_buf->bytesReceived++;
            COM_buf->r [COM_buf->rpos] = getche ();
            COM_buf->rpos++;
          }

          #endif
          return 0;
        }
      }
      else
      {
        rest = R_BUF_SIZE - COM_buf->rend;
        memcpy (s, (char *)COM_buf->r+COM_buf->rpos, rest);
        memcpy (s+rest, (char *)COM_buf->r, dataSize - rest);
        COM_buf->rend = dataSize - rest;
        return dataSize;
      }
    }
    else
    {
      return 0;
    }
  }
  else
  {
    return 0;
  }
}

int COM_getchar (void)
{
  int c;

  if (COM_user)
  {
    if (COM_buf->rpos != COM_buf->rend)
    {
      c = (unsigned char) COM_buf->r [COM_buf->rend];
      COM_buf->rend++;
      if (COM_buf->rend == R_BUF_SIZE)
        COM_buf->rend = 0;
      return c;
    }
    else
    {
      #ifdef COM_DEBUG

      if (kbhit ())
      {
        COM_buf->bytesReceived++;
        COM_buf->r [COM_buf->rpos] = getche ();
        COM_buf->rpos++;
      }

      #endif

      return -1;
    }
  }
  else
  {
    return -1;
  }
}

int COM_putchar (int c)
{
  if (COM_user)
  {
    if ((COM_buf->send == COM_buf->spos) && (!COM_buf->sendLock))
    {
      outp (COM_addr, c);
      COM_buf->sendLock=1;
      COM_buf->bytesSent++;
    }
    else
    {
      COM_buf->s [COM_buf->send] = c;
      COM_buf->send++;
      if (COM_buf->send == S_BUF_SIZE)
      {
        COM_buf->send = 0;
      }
    }
  }
  return c;
}

void COM_send (char *s, int dataSize)
{
  COM_sendData ((char *)&dataSize, 2);
  COM_sendData (s, dataSize);
}

static long COM_handleCommand (TCOMPacket *cp)
{
  switch (cp->command)
  {
    case COM_COMMAND_LOGIN:
    case COM_COMMAND_LOGINSLAVE:
    case COM_COMMAND_LOGINMASTER:
    {
      memcpy (COM_remoteName, cp->name, COM_NAME_MAXLEN);
      break;
    }
    case COM_COMMAND_LOGOUT:
    {
      COM_user = COM_USER_NOTHING;
      COM_buf->receiveLock=1;
      break;
    }
    case COM_COMMAND_ID:
    {
      return COM_COMMAND_NOTHING;
    }
  }
  COM_command = cp->command;

  return cp->command;
}


int COM_receive (char *s)
{
  TCOMPacket cp;
  unsigned short dataSize;

  while (dataSize = 0, COM_receiveData ((char *)&dataSize, 2), dataSize == COM_DATA_COMMAND)
  {
    COM_receiveData ((char *)&cp, sizeof (TCOMPacket));
    COM_handleCommand (&cp);
  }

  return COM_receiveData (s, dataSize);
}

static void COM_sendCommand (long command)
{
  TCOMPacket cp = {0};
  unsigned short dataSize=COM_DATA_COMMAND;

  cp.command = command;
  switch (command)
  {
    case COM_COMMAND_LOGOUT:
    case COM_COMMAND_LOGIN:
    case COM_COMMAND_LOGINMASTER:
    case COM_COMMAND_LOGINSLAVE:
    {
      memcpy (cp.name, COM_localName, COM_NAME_MAXLEN);
      break;
    }
  }

  COM_sendData ((char *)&dataSize, 2);
  COM_sendData ((char *)&cp, sizeof (TCOMPacket) );

  TIMER_delay (COM_SENDCOMMAND_DELAY);
}


static long COM_recCommand (void)
{
  TCOMPacket cp;
  unsigned short dataSize;

  if (COM_receiveData ((char *) &dataSize, 2))
  {
    if (dataSize == COM_DATA_COMMAND)
    {
      while (!COM_receiveData ((char *) &cp, sizeof (TCOMPacket)))
        ;

      return COM_handleCommand (&cp);

    }
  }
  return COM_COMMAND_NOTHING;
}

static int COM_countSpeed (int speed)
{
  switch (speed)
  {
    case COM_110BAUDS:
      COM_baudSpeed = 110;
      break;
    case COM_150BAUDS:
      COM_baudSpeed = 150;
      break;
    case COM_300BAUDS:
      COM_baudSpeed = 300;
      break;
    case COM_600BAUDS:
      COM_baudSpeed = 600;
      break;
    case COM_1200BAUDS:
      COM_baudSpeed = 1200;
      break;
    case COM_2400BAUDS:
      COM_baudSpeed = 2400;
      break;
    case COM_4800BAUDS:
      COM_baudSpeed = 4800;
      break;
    case COM_9600BAUDS:
      COM_baudSpeed = 9600;
      break;
    case COM_19200BAUDS:
      COM_baudSpeed = 19200;
      break;
    case COM_38400BAUDS:
      COM_baudSpeed = 38400;
      break;
    case COM_57600BAUDS:
      COM_baudSpeed = 57600;
      break;
    case COM_115200BAUDS:
      COM_baudSpeed = 115200;
      break;
    default:
      COM_baudSpeed = COM_byteSpeed = 0;
      return 1;
  }
  COM_byteSpeed = COM_baudSpeed / 8;

  return 0;
}

static void COM_setSpeed (int speed)
{
  int lospeed;
  int hispeed;

  COM_speed = speed;

  lospeed = los (speed);
  hispeed = his (speed);

  outp (COM_addr+COM_PORTSETUP, COM_PORTSETSPEED); // 3, 80
  outp (COM_addr, lospeed);
  outp (COM_addr+1, hispeed);
}

static void COM_getBIOSPortsAddr (void)
{
  memcpy (COM_portAddr+1, MK_DP (BIOS_SEG, BIOS_COM_PORTS), sizeof COM_portAddr-1);
}

extern "C" void interrupt far COM_buf16 (void);

void COM_init (void)
{
  COM_done ();

  COM_getBIOSPortsAddr ();

  if (COM_buf == NULL)
  {
//    _atexit (COM_done);
    COM_buf = (TCOM_buf *) DPMI_alloc (64000);

    if (COM_buf == NULL)
    {
      CGDK_exit ("Not enough memory for 16-bit serial communication IRQ buffer.\n", EXIT_FAILURE);
    }
    #ifdef __TURBOC__
    memset ((char *)COM_buf, 0, sizeof (TCOM_buf));
    #else
    memcpy ((char *)COM_buf, (void *) &COM_buf16, 64000);
    #endif
  }
}

int COM_setup (int port, int irq, int speed) // , int portout, int irqout)
{
  unsigned char c;
  REGS regs;
  long addr;

  COM_restore ();

  if ((port < 1) || (port > 4))
  {
    return COM_INITERR_PORT;
  }
  if ((irq > 7) || (irq < -1))
  {
    return COM_INITERR_IRQ;
  }

  if (COM_countSpeed (speed) != 0)
    return 1;

  COM_addr = COM_portAddr [port];
  if (COM_addr == 0)
  {
    return COM_INITERR_PORT;
  }

  if (irq == COM_INTERRUPT_AUTODETECT)
  {
    irq = COM_irqNum [port];
  }

  COM_irq = irq;
  COM_port = port;
  COM_int = COM_irqInt [irq];

  COM_buf->bytesReceived=0;
  COM_buf->bytesSent=0;
  COM_buf->rpos = COM_buf->rend = 0;
  COM_buf->spos = COM_buf->send = 0;
  COM_buf->receiveLock = 1;
  COM_buf->addr = COM_addr;

  if (COM_irqOld == NULL)
  {
    COM_irqOld = _dos_getvect (COM_int);
    _dos_setvect(COM_int, COM_irqHandler);
    #ifndef __TURBOC__
      COM_irqOld16 = DPMI_getRealModeVector (COM_int);
      addr = (DP_SEG (COM_buf) << 16) + DP_OFF (COM_buf) + sizeof (TCOM_buf);
      DPMI_setRealModeVector (COM_int, addr);
    #endif
  }

  regs.x.eax = 0x00E3;
  regs.x.edx = COM_port-1;
  int386 (COM_BIOS_INTERRUPT, &regs, &regs);
  DPMI_disableInt ();
  COM_setSpeed (speed);
  outp (COM_addr+COM_PORTSETUP, COM_PORTSETUPNORMAL); // 3 3
  inp (COM_addr+COM_PORTSTATUS);
//  c = inp (COM_addr+COM_PORTMODEM);
//  c = setBit (c, COM_OUT2BIT);
  outp (COM_addr+COM_PORTMODEM,COM_OUT2); // 4 8
  inp (COM_addr+COM_INTID);
  inp (COM_addr);
  outp (COM_addr+COM_PORTINTERRUPTS, COM_INTBOTH); // COM_INTBOTH); // 1 3
  c = inp (PIC_IRQ);
  c = resetBit (c, irq);
  outp (PIC_IRQ, c);
  DPMI_enableInt ();

//  outp (COM_addr, 'I');
//  COM_buf->sendLock=1;

  COM_user = COM_USER_NOTHING;

  return 0;
}

void COM_restore (void)
{
  REGS regs;
  long time;

  if (COM_irqOld)
  {
    time = TIMER_timeTotal;

    while (COM_buf->send != COM_buf->spos)
    {
      if ((TIMER_timeTotal - time) > COM_DONE_DELAY)
        break;
    }

    COM_buf->receiveLock=1;
    COM_user = COM_USER_NOTHING;

    outp (COM_addr+COM_PORTINTERRUPTS, 0xF0);
    regs.x.eax = 0x00E3;
    regs.x.edx = COM_port-1;
    int386 (COM_BIOS_INTERRUPT, &regs, &regs);
    _dos_setvect (COM_int, COM_irqOld);
    #ifndef __TURBOC__
      DPMI_setRealModeVector (COM_int, COM_irqOld16);
    #endif
    COM_irqOld = NULL;
  }
}

void COM_done (void)
{
  COM_restore ();

  COM_port = 0;
  COM_addr = 0;
  COM_irq = 0;
  COM_int = 0;
  COM_speed = 0;
  COM_baudSpeed = 0;
  COM_byteSpeed = 0;
  COM_command = 0;
  COM_user = 0;

  if (COM_buf)
  {
    DPMI_free (COM_buf);
    COM_buf = NULL;
  }
}


#define OK 1
#define CANCEL 2


static void COM_sendId (void)
{
  COM_sendData (idRight, sizeof (TID));
}


/*
static int go (long time)
{
  if (time > TIMER_ticks)
    return 1;
  else
    return 0;
}
*/

static int COM_log (int who, char *name, int (*waitHandler) (void))
{
  int exitCode;
  long ticks;
  long tt;
  long ms;
  int idPos;
  int c;
  long result;
  long backCommand;
  long initCommand;
  char *defName;

  if (COM_user == COM_USER_NOTHING)
  {
    switch (who)
    {
      case COM_USER_PEER:
        initCommand = COM_COMMAND_LOGIN;
        backCommand = COM_COMMAND_LOGIN;
        defName = COM_defNamePeer;
        break;
      case COM_USER_MASTER:
        initCommand = COM_COMMAND_LOGINMASTER;
        backCommand = COM_COMMAND_LOGINSLAVE;
        defName = COM_defNameMaster;
        break;
      case COM_USER_SLAVE:
        initCommand = COM_COMMAND_LOGINSLAVE;
        backCommand = COM_COMMAND_LOGINMASTER;
        defName = COM_defNameSlave;
        break;
      default:
      {
        return 3;
      }
    }
    if (*name == 0)
    {
      name = defName;
    }

    memcpy (COM_localName, name, COM_NAME_MAXLEN);
    COM_localName [COM_NAME_MAXLEN] = 0;

    COM_user = COM_USER_TEMP;
    COM_buf->receiveLock=0;

    exitCode = 0;

    waitHandler ();

    COM_buf->rend = COM_buf->rpos = 0;
    COM_buf->send = COM_buf->spos = 0;

    do
    {
      if (who != COM_USER_SLAVE)
      {
        COM_sendId ();
        COM_sendCommand (initCommand);
      }

      idPos = 0;
 //     ticks = TIMER_ticks;
      ms = TIMER_timeTotal + COM_LOG_DELAY;

      while (ms > TIMER_timeTotal)
      {
//        if (kbhit ())
       {

        }
        c = COM_getchar ();
        if (c != -1)
        {
          if ((unsigned char)idRight [idPos] == c)
          {
            idPos++;
            if (idPos == ID_LEN) // -1
            {
//            while (COM_getchar ()==-1)
//              ;
//            time2 = TIMER_ticks;

              while (result = COM_recCommand (), result == COM_COMMAND_NOTHING)
              {
//              if (((1000*(TIMER_ticks - time2))/TIMER_FREQ) > 333)
//              {
//                break;
//              }
              }
              if (result == backCommand)
              {
                if (who != COM_USER_MASTER)
                {
                   COM_sendId ();
                   COM_sendCommand (initCommand);
                }
                exitCode = OK;
                break;
              }
              else
              {
                idPos = 0;
              }
            }
          }
          else
          {
            if ((unsigned char) idRight [0] == c)
              idPos = 1;
            else
              idPos = 0;
          }
        }
      }

      if (!exitCode)
      {
        if (waitHandler)
        {
          if (waitHandler ())
          {
            exitCode = CANCEL;
          }
        }
      }
//      printf ("%li > %li\n", TIMER_ticks, ms);
//      if (tt < ms)
//        printf ("Error !\n");
    }
    while (!exitCode);

    if (exitCode == OK)
    {
      COM_user = who;
      return 0;
    }
    else
    {
      COM_buf->receiveLock = 1;
      COM_user = COM_USER_NOTHING;
      return 1;
    }
  }
  return 2;
}


extern "C" int COM_login (char *name, int (*waitHandler) (void) )
{
  return COM_log (COM_USER_PEER, name, waitHandler);
}

extern "C" int COM_create (char *name, int (*waitHandler) (void) )
{
  return COM_log (COM_USER_MASTER, name, waitHandler);
}

extern "C" int COM_join (char *name, int (*waitHandler) (void) )
{
  return COM_log (COM_USER_SLAVE, name, waitHandler);
}

void COM_logout (void)
{
  COM_sendCommand (COM_COMMAND_LOGOUT);
  COM_buf->receiveLock = 1;
  COM_user = COM_USER_NOTHING;
}
