
#ifndef _VGA_H_
  #define _VGA_H_

  #ifdef __cplusplus
  extern "C" {
  #endif


  #include "l256_.h"

  #define VGA_SEG 0xA000
  #define VGA_SEGMONO 0xB000
  #define VGA_SEGTEXT 0xB800

  #define VGA_INT 0x10

  #define VGA_640x400x16 0x12
  #define VGA_320x200x256 0x13

  #define VGA_320x200x16 0x0D
  #define VGA_640x200x16 0x0E
  #define VGA_640x350x16 0x10
  #define VGA_640x480x16 0x12
  #define VGA_320x200x256 0x13

  #define VGA_80x50x16TM 0x04
  #define VGA_80xXXx16TM 0x05
  #define VGA_40x25x16TM 0x00
  #define VGA_40x25x16TC 0x01
  #define VGA_80x25x16TM 0x02
  #define VGA_80x25x16TC 0x03
  #define VGA_80x25x10TM 0x07
  #define VGA_TEXTMODE 0x07

  #define VGA_MAXMODE 0x13

  #define SEQU_ADDR 0x3C4
  extern int CRTC_ADDR;
  extern int STATUS_ADDR;

  extern void *SVGA_videoBuf;
  extern int VGA_installed;
//  extern long SVGA_timer;

//  int VGA_getCRTCAddr (void);
//  int VGA_getStatusAddr (void);
  void VGA_init (void);

  int SVGA_retraceDetect (void);
  void SVGA_retraceStart (void);
  void SVGA_retraceEnd (void);
  void SVGA_waitVerticalRetrace (int count); // = 1
  void SVGA_wait (int count); // = 1
  void SVGA_waitRetrace (int count);
//  void SVGA_waitRevert (int count);
  void *SVGA_getVideoBuf (int mode);

  int SVGA_returnVideoMode (void);
  int VGA_setVideoMode (int Mode);
  void VGA_switchVideoMode (int Mode);
  int VGA_getModeInfo (int videoMode, int *xRes, int *yRes,
			int *bytesPerPixel,int *bitsPerPixel);

  void *VGA_saveState (void);
  void VGA_restoreState (void *stateBuf);


  #ifdef __cplusplus
  }
  #endif

#endif
