
#ifndef _XVGA_H
  #define _XVGA_H

  #ifdef __cplusplus
  extern "C" {
  #endif


  #include "x256_.h"

//  #define XVGA_SETMODE_OK 0
//  #define XVGA_SETMODE_NOSUPPORT 0x21
//  #define XVGA_SETMODE_NOVGA 0x22

  #define XVGA 0x1000
  #define NO_SCROLL 0x8000

  #define XVGA_256x200x256 XVGA+0x00
  #define XVGA_256x224x256 XVGA+0x01
  #define XVGA_256x240x256 XVGA+0x02
  #define XVGA_256x400x256 XVGA+0x03
  #define XVGA_256x480x256 XVGA+0x04
  #define XVGA_256x256x256 XVGA+0x05
  #define XVGA_320x200x256 XVGA+0x06
  #define XVGA_320x240x256 XVGA+0x07
  #define XVGA_320x400x256 XVGA+0x08
  #define XVGA_320x480x256 XVGA+0x09
  #define XVGA_360x200x256 XVGA+0x0A
  #define XVGA_360x240x256 XVGA+0x0B
  #define XVGA_360x270x256 XVGA+0x0C
  #define XVGA_360x400x256 XVGA+0x0D
  #define XVGA_360x480x256 XVGA+0x0E
  #define XVGA_360x360x256 XVGA+0x0F
  #define XVGA_376x282x256 XVGA+0x10
  #define XVGA_376x308x256 XVGA+0x11
  #define XVGA_376x564x256 XVGA+0x12
  #define XVGA_400x300x256 XVGA+0x13

  #define XVGA_VGA 0
  #define XVGA_ET3000 1
  #define XVGA_ET4000 2

  extern int XVGA_readPlane;
  extern int XVGA_writePlane;
  extern void XVGA_setWritePlane (int plane);
  extern void XVGA_setReadPlane (int plane);

  extern void XVGA_scroll ();
//  extern int  XVGA_installed (void);
  extern int XVGA_setVideoMode (int mode); //  = XVGA_320x240x256
  int XVGA_getModeInfo (int Mode, int *XRes, int *YRes,
                          int *BytesPerLine,int *BitsPerPixel);
  extern void XVGA_raw2Planar (void *Dst, void *Src, int SIZE_X, int SIZE_Y);
  extern void XVGA_planar2Raw (void *Dst, void *Src, int SIZE_X, int SIZE_Y);
  extern void XVGA_updateCurPos (int X, int Y);
  extern int XVGA_videoModeSupported (int VideoMode);
  extern void XVGA_init (void);

  extern int XVGA_columns;

//  void XVGA_SetChipset (int Chipset);
//  void XVGA_DetectChipset (void);

  #ifdef __cplusplus
  }
  #endif

#endif
